/*
 *      Beispielprogramm 11, Abschnitt 7
 *      Programm zum Finden von Zeilen, die ein anzugebendes
 *      Suchmuster enthalten bzw. nicht enthalten
 *      Aufruf: find [-n] [-x] suchmuster 
 */
 
#include <stdio.h>

#define MAXLINE 1000

int getline(char [], int);
int index(char [], char []);

void main(int argc, char *argv[])
{
  char line[MAXLINE], *s;
  long lineno = 0;
  int except = 0, number = 0;
  
  while (--argc > 0 && (*++argv)[0] == '-')
    for (s = argv[0]+1; *s != '\0'; s++)
      switch (*s) {
	case 'x':
	  except = 1;
	  break;
	case 'n':
	  number = 1;
	  break;
	default:
	  printf("find: illegal option %c\n",*s);
	  argc = 0;
	  break;
      }

  if (argc != 1)
    printf("Usage: find [-x] [-n] pattern\n");
  else
    while (getline(line, MAXLINE) > 0) {
      lineno++;
      if ((index(line, *argv) >= 0) != except) {
	if (number)
	  printf("%ld: ",lineno);
	printf("%s",line);
      }
    }

} /* main() */

/* Zeile in s ablegen, Laenge liefern */
int getline(char s[], int lim)
{ 
  int c, i;
  
  i = 0;
  while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
    s[i++] = c;
  if (c == '\n')
    s[i++] = c;
  s[i] = '\0';
  return(i);

} /* getline() */

/* Position von t in s liefern, -1 falls nicht da */
int index (char s[], char t[])    
{ 
  int i, j, k;
  
  for (i = 0; s[i] != '\0'; i++) {
    for (j = i, k = 0; t[k] != '\0' && s[j] == t[k]; j++, k++)
      ;
    if (t[k] == '\0')
      return(i);
  }
  return(-1);
  
} /* index() */
