/*
 *      p8-1.c
 *      Beispielprogramm 1, Abschnitt 8
 *      Vorkommen reservierter Woerter zaehlen 
 */

#include <stdio.h>
#include <string.h>

#define MAXWORD 20
#define NKEYS (sizeof(keytab) / sizeof(struct key))
#define LETTER 'a'
#define DIGIT '0'

struct key {   /* global, daher initialisierbar */
  char *keyword;
  int keycount;
} keytab[] = {
  "auto", 0,
  "break", 0,
  "case", 0,
  "char", 0,
  "const", 0,
  "continue", 0,
  "default", 0,
  "do", 0,
  "double", 0,
  "else", 0,
  "enum", 0,
  "extern", 0,
  "float", 0,
  "for", 0,
  "goto", 0,
  "if", 0,
  "int", 0,
  "long", 0,
  "register", 0,
  "return", 0,
  "short", 0,
  "signed", 0,
  "sizeof", 0,
  "static", 0,
  "struct", 0,
  "switch", 0,
  "typedef", 0,
  "union", 0,
  "unsigned", 0,
  "void", 0,
  "volatile", 0,
  "while", 0,
};

int binary(char *, struct key[], int);
int getword(char *, int);
int type(int);

void main(void)
{
  int n, t;
  char word[MAXWORD];
  
  while ((t = getword(word, MAXWORD)) != EOF)
    if (t == LETTER)
      if ((n = binary(word, keytab, NKEYS)) >= 0)
	keytab[n].keycount++;
	
  for (n = 0; n < NKEYS; n++)
    if (keytab[n].keycount > 0)
      printf("%4d %s\n", keytab[n].keycount, keytab[n].keyword);
      
} /* main() */

/* word in tab[0],...,tab[n-1] finden */
int binary(char *word, struct key tab[], int n)
{
  int low, high, mid, cond;
  
  low = 0;
  high = n - 1;
  while (low <= high) {
    mid = (low + high) / 2;
    if ((cond = strcmp(word, tab[mid].keyword)) < 0)
      high = mid - 1;
    else if (cond > 0)
      low = mid + 1;
    else
      return(mid);
  }
  return(-1);
  
} /* binary() */

#define getch() getc(stdin)
#define ungetch(c) ungetc(c, stdin)
 
/* naechstes Wort aus der Eingabe holen */
int getword(char *w, int lim)
{
  int c, t;
  
  if (type(c = *w++ = getch()) != LETTER) {
    *w = '\0';
    return(c);
  }
  while (--lim > 0) {
    t = type(c= *w++ = getch());
    if (t != LETTER && t != DIGIT) {
      ungetch(c);
      break;
    }
  }
  *(w-1) = '\0';
  return(LETTER);

} /* getword() */

/* Typ eines ASCII Zeichens liefern */
int type(int c)
{
  if (c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z')
    return(LETTER);
  else if (c >= '0' && c <= '9')
    return(DIGIT);
  else
    return(c);

} /* type() */
