/*
 *      mem2.c
 *      klin, Wed Dec 17 15:08:57 1997
 *      Speicherabbildung von Feldern und Strings
 */

#include <stdio.h>
#include <ctype.h>

#define N 2
#define M 8
#define byte unsigned char

char a1[N][M] = {
  { 'a', '1', '-', '1', '\0' },
  { 'a', '1', '-', '2', '\0' },
};

char a2[N][M] = { 
  "a2-1", 
  "a2-2", 
};

char *a3[N] = {
  "a3-1",
  "a3-2",
};

void puthex(byte *, int);

void main(void)
{
  int i;
  
  printf("Speicherabbildung von Feldern und Strings\n\n");
      
  printf("a1  a = %p/%p  s = %d\n", a1, &a1, sizeof(a1));
  puthex((byte *) a1, sizeof(a1));
  for (i = 0; i < N; i++)
    printf("a1(%d) = %p/%p \"%s\"\n", i, a1[i], &a1[i], a1[i]);

  printf("a2  a = %p/%p  s = %d\n", a2, &a2, sizeof(a2));
  puthex((byte *) a2, sizeof(a2));
  for (i = 0; i < N; i++)
    printf("a2(%d) = %p/%p \"%s\"\n", i, a2[i], &a2[i], a2[i]);
    
  printf("a3  a = %p/%p  s = %d\n", a3, &a3, sizeof(a3));
  puthex((byte *) a3, sizeof(a3));
  for (i = 0; i < N; i++)
    printf("a3(%d) = %p/%p \"%s\"\n", i, a3[i], &a3[i], a3[i]);
  for (i = 0; i < N; i++)  
    puthex((byte *) a3[i], 8);

} /* main() */

void puthex(byte *s, int n)
{
  int i;
  
  for (i = 0; i < n; i++) {
    printf("%02x", s[i]);
  }
  printf("\n");
  for (i = 0; i < n; i++) {
    printf("%2c", isprint(s[i]) ? s[i] : '.');
  }
  printf("\n");

} /* puthex() */
